#!/bin/bash

temporal='tmp'
destino='resultado'
origen='graficar'

function graficar(){
	prefijo=$1
	archivo=$origen/$prefijo.params
	plantilla_c=calcular.c
	plantilla_gnuplot=graficar.gnuplot
	resultado_c=$temporal/$prefijo.c
	resultado_gnuplot=$prefijo.gnuplot
	resultado_ext=eps
	resultado_ext2=tex
	exito_ext=' ✔'
	ejecutable=$prefijo.out
	substituir="-e 's/#prefijo#/$prefijo/'"
	
	rm "$temporal/$prefijo"*
	rm "$destino/$prefijo"*
	
	while read line
	do
		substituir="$substituir -e 's/#${line// = /#\/}/'"

	done < $archivo
	
	substituir="$substituir -e 's/α/alfa/g'"
	substituir="$substituir -e 's/μ/mu/g'"
	substituir="$substituir -e 's/∞/inf/g'"

	eval "sed $substituir $plantilla_c" > $resultado_c

	echo "Archivo: $archivo"
	echo "Compilando..."

	gcc -lm "$resultado_c" -o "$temporal/$ejecutable"

	eval "sed $substituir $plantilla_gnuplot" > $temporal/$resultado_gnuplot

	cd $temporal
	echo "Ejecutando..."
	./$ejecutable && echo "Graficando..." && gnuplot $resultado_gnuplot
	
	cd ..
	
	echo "Guardando el resultado..."
	
	cp "$archivo" "$temporal/$prefijo"*".$resultado_ext" "$destino"
	cp "$archivo" "$temporal/$prefijo"*".$resultado_ext2" "$destino"
	mv "$archivo" "$archivo$exito_ext"
	
	echo "Listo."
}

cp YlGnBu.plt $temporal/

#if [ $1 == 'recalcular' ] then
#	for i in $origen/*.params.graficado
#	do
#		prefijo=${i#"$origen/"}
#		mv $i $origen/prefijo.params
#	done
#fi

ulimit -s 1048576

for i in $origen/*.params
do
	prefijo=${i#"$origen/"}
	graficar ${prefijo%.params}
done

echo "Todos los archivos graficados."
